#include "jstrings.h"
#include <string.h>

static void getlongopt(char *argument);

static void usage(char *argv) {
	fprintf(stderr, "%s\n", FULLVERSION);
	fprintf(stderr, "Japanese version 'strings'.\n");
	fprintf(stderr, "Copyrights(c) TAKAHASHI Motonobu 2003\n");
	fprintf(stderr, "%s [-HhlmnV] Encoding [Encodings...]\n", argv);
	fprintf(stderr, "   -l    display checked encoding.\n");
	fprintf(stderr, "   -m    set min len of strings to pick up\n");
	fprintf(stderr, "   -n    display offset (bytes).\n");
	fprintf(stderr, "   -V    Print Version\n");
	fprintf(stderr, "   -[Hh] Print Help\n");
	fprintf(stderr, "   --ascii   pick up ASCII strings\n");
	fprintf(stderr, "   --eucjp   pick up EUC-JP strings\n");
	fprintf(stderr, "   --euc-jp  pick up EUC-JP strings\n");
	fprintf(stderr, "   --cp932   pick up CP932 strings\n");
}

void my_getopts(int argc, char* argv[]) {
	int i;

	if (argc < 2) {
		usage(argv[0]);
		exit(0);
	}

	memset(&stOptions, 0, sizeof(stOptions));
	stOptions.min_len = 5;

	for (i = 1; i < argc; i++) {
		if ((argv[i][0] == '-') && (argv[i][1] == '-')) {
			getlongopt(argv[i]);
		}
		else if ((argv[i][0] == '-') && (argv[i][1] == 'm')) {
			i++;
			stOptions.min_len = atoi(argv[i]);
		}
		else if (argv[i][0] == '-') {
			int j = 1;
			while (argv[i][j] != 0) {
				switch (argv[i][j]) {
				case 'H':
				case 'h':
					usage(argv[0]);
					exit(0);
					break;
				case 'l':
					stOptions.show_lang = TRUE;
					break;
				case 'm':
					/* */
					break;
				case 'n':
					stOptions.show_linenumber = TRUE;
					break;
				case 'V':
					printf("%s\n", argv[0], FULLVERSION);
					exit(0);
					break;
				default:
					usage(argv[0]);
					exit(1);
					break;
				}
				j++;
			}
		}
		else {
			usage(argv[0]);
			exit(1);
		}
	}
}

static void getlongopt(char *argument) {
	if (strlen(argument) < 3)
		return;
	else if (!strcmp("ascii", argument+2))
		stOptions.ascii = TRUE;
	else if (!strcmp("eucjp", argument+2))
		stOptions.eucjp = TRUE;
	else if (!strcmp("euc-jp", argument+2))
		stOptions.eucjp = TRUE;
	else if (!strcmp("cp932", argument+2))
		stOptions.cp932 = TRUE;
}