#include "jstrings.h"

/* temporary */
#define MAX_ASCIICHARLEN 1

static unsigned short ch_count = 0;
static unsigned short len_count = 0;
static unsigned char ch_buf[MAX_BUFLEN] = {0};
static unsigned char ch_pos = 0;
static unsigned long current_offset = 0;
static unsigned char ch_tmpbuf[MAX_CHARLEN] = {0};
static int is_ascii(const unsigned char ch, unsigned char *);

int strings_ascii(const unsigned char ch, unsigned long *file_offset) {
	int size;
	/* if (!offset) NOT one of ASCII */
	if ((file_offset == NULL) || ((size = is_ascii(ch, &ch_tmpbuf[0])) < 0)) {
		/* ch is NOT one of ASCII */
		if (ch_count >= stOptions.min_len) {
			if (stOptions.show_lang)
				printf("%s:", "ASCII");
			if (stOptions.show_linenumber)
				printf("%6ld:", current_offset);
			printf(" %s\n", ch_buf);
		}
		memset(ch_buf, 0, MAX_BUFLEN);
		memset(ch_tmpbuf, 0, (MAX_ASCIICHARLEN+1));
		ch_count = 0; len_count = 0; ch_pos = 0;
	}
	else if (size == 0) {
		/* we cannot determine if ch is one of current charset or not yet */
		/* never reached */
	}
	else { /* size > 0 */
		/* ch is one of current charset */
		strncpy(&ch_buf[len_count], ch_tmpbuf, size);
		if (ch_count == 0)
			current_offset = *file_offset;
		len_count+=size; ch_count++;
	}

	if (len_count >= (MAX_BUFLEN - MAX_ASCIICHARLEN)) {
		return FALSE;
	}
	else
		return TRUE;
}

static int is_ascii(const unsigned char ch, unsigned char *tmpbuf) {
	if      (((ch >= 0x20) && (ch <= 0x7e)) || (ch == '\t')) {
		tmpbuf[0] = ch;
		return 1;
	}
	else
		return -1;
}
